/**
 * @file tinyio.h
 *
 * stdio.h ̊ȈՔŁB
 * IWi iruka B肪Ƃ܂B
 *
 * @author Komatsudaira Yoshiki
 * @version $Id: tinyio.h 12 2006-11-10 14:58:02Z komatsu $
 */

#include <tchar.h>
#include <stdarg.h>
#include <windows.h>


#ifndef TINYIO_H
#define	TINYIO_H


#ifdef __cplusplus
extern "C" {
#endif


typedef struct	{
	int     	flags;		/* tOrbg          	       */
	int 		fd;			/* WinCẼt@Cnh         */

	unsigned char *buffer;	/* Xg[Eobt@            */
	unsigned char *curp;	/* [̓ǂݏ|C^    */
	unsigned char *eofp;	/* [̓ǂݍݎ|C^̍ŏIʒu */
	unsigned char *endp;	/* [̏ݎ|C^̍ŏIʒu */
	int 		bsize;		/* Xg[Eobt@̊mۃTCY         */
	int			level;		/* Xg[Eobt@̎gpoCg       */

	char  		token;		/* FILE\̂gpȂ...1      */
	char  		istty;		/* TTY INȂ1 OUTȂ2 t@C=0 */
	char		hold;		/* ungetc()pz[hobt@      */
	char		iobuf;		/* _IOFBF/_IOLBF			       */

	CRITICAL_SECTION	cs;
	CRITICAL_SECTION	cs_fwrite;

} LIBCE_FILE;

#define	FILE	LIBCE_FILE

#define _IOFBF       0x0000
#define _IOLBF       0x0001
#define _IONBF       0x0002
#define _IOBMASK     0x0003

#define _IOREAD      0x0004
#define _IOWRITE     0x0008
#define _IOAPPEND    0x0010
#define _IOTRUNC     0x0020
#define _IOCREAT     0x0040
#define _IOBIN       0x0080
#define _IOFREE      0x0100
#define _IOEOF       0x0200
#define _IOERR       0x0400
#define _LIBCE_IOR         0x0800
#define _LIBCE_IOW         0x1000
#define _IOAPPLS     0x2000
#define _IOEMU       0x4000
#define _IOUPD       (_IOREAD | _IOWRITE)

#define EOF		(-1)			/* End of file indicator */

#ifndef	NULL
#define	NULL		0
#endif

#define BUFSIZ	4096			/* Buffer size for stdio */

#if 0
#define SEEK_SET	FILE_BEGIN
#define SEEK_CUR	FILE_CURRENT
#define SEEK_END	FILE_END
#endif

extern	FILE	_streams[];

#undef stdin
#define stdin	(&_streams[0])
#undef stdout
#define stdout	(&_streams[1])
#undef stderr
#define stderr	(&_streams[2])

typedef unsigned size_t;


void celib_init(void);

int		libce_fclose(FILE *fp);
int		libce_fflush(FILE *fp);
int		libce_fgetc(FILE *fp);
char*	libce_fgets(char *s, int n, FILE *fp);
FILE*	libce_fopen(const char *filename, char *mode);
int		libce_fputc(char c, FILE *fp);
int		libce_fputs(char *s, FILE *fp);
int		libce_fread(void *ptr, unsigned size, unsigned n, FILE *fp);
FILE*	libce_freopen(char *filename, char *mode, FILE *oldfile);
int		libce_fseek(FILE *fp, long offset, int whence);
long	libce_ftell(FILE *fp);
int		libce_fwrite(void *ptr, unsigned size, unsigned n, FILE *fp);
char*	libce_gets(char *s);
int		libce_puts(char *s);
int		libce_ungetc (int c, FILE *fp);

int		libce_fprintf(FILE *fp, char *format, ...);
int		libce_printf(char *format, ...);
int		libce_sprintf(char *buffer, char *format, ...);
int		libce_vfprintf(FILE *fp, char *format, va_list arglist);
int		libce_vprintf(char *format, va_list arglist);
int		libce_vsprintf(char *buffer, const char *format, va_list arglist);

void cwin_exit( int r );

int		libce_fwprintf(FILE *fp, TCHAR *fmt, ...);
TCHAR*	libce_fgetws(TCHAR *dst, size_t sz, FILE *fp);


#define	fclose		libce_fclose
#define	fflush		libce_fflush
#define	fgetc		libce_fgetc
#define	fgets		libce_fgets
#define	fopen		libce_fopen
#define	fputc		libce_fputc
#define	fputs		libce_fputs
#define	fread		libce_fread
#define	freopen		libce_freopen
#define	fseek		libce_fseek
#define	ftell		libce_ftell
#define	fwrite		libce_fwrite
#define	gets		libce_gets
#define	puts		libce_puts

#define	fprintf		libce_fprintf
#define	sprintf		libce_sprintf
#define	vsprintf	libce_vsprintf
#define	fwprintf	libce_fwprintf
#define	fgetws		libce_fgetws


/*	The following macros provide for common functions */

#define ferror(f)	((f)->flags & _IOERR)
#define feof(f)		((f)->flags & _IOEOF)
#undef fileno
#define fileno(f)	((f)->fd)
#define remove(filename) unlink(filename)


#ifdef __NO_STDIO_INLINE__

#define getc fgetc
#define putc fputc

#else

#undef getc
#define getc(fp) \
    ((fp)->curp < (fp)->eofp ? (*(fp)->curp++) : fgetc (fp))

#undef putc
#define putc(c, fp) \
    ((fp)->curp < (fp)->endp ? (*(fp)->curp++ = (c)) : fputc ((c), (fp)))

#endif

#define getchar()  (fgetc (stdin))
#define putchar(c) (fputc ((c), stdout))
#define	exit(n)	   cwin_exit(n)


#ifdef __cplusplus
}
#endif


#endif
